# Generated by the protocol buffer compiler.  DO NOT EDIT!
# Source: murmur_rpc/murmur_rpc.proto for package 'MurmurRPC'
# Original file comments:
# Copyright 2005-2020 The Mumble Developers. All rights reserved.
# Use of this source code is governed by a BSD-style license
# that can be found in the LICENSE file at the root of the
# Mumble source tree or at <https://www.mumble.info/LICENSE>.
#

require 'grpc'
require 'murmur_rpc/murmur_rpc_pb'

module MurmurRPC
  module V1
    class Service

      include GRPC::GenericService

      self.marshal_class_method = :encode
      self.unmarshal_class_method = :decode
      self.service_name = 'MurmurRPC.V1'

      # GetUptime returns murmur's uptime.
      rpc :GetUptime, ::MurmurRPC::Void, ::MurmurRPC::Uptime
      # GetVersion returns murmur's version.
      rpc :GetVersion, ::MurmurRPC::Void, ::MurmurRPC::Version
      # Events returns a stream of murmur events.
      rpc :Events, ::MurmurRPC::Void, stream(::MurmurRPC::Event)
      #
      # Servers
      #
      #
      # ServerCreate creates a new virtual server. The returned server object
      # contains the newly created server's ID.
      rpc :ServerCreate, ::MurmurRPC::Void, ::MurmurRPC::Server
      # ServerQuery returns a list of servers that match the given query.
      rpc :ServerQuery, ::MurmurRPC::Server::Query, ::MurmurRPC::Server::List
      # ServerGet returns information about the given server.
      rpc :ServerGet, ::MurmurRPC::Server, ::MurmurRPC::Server
      # ServerStart starts the given stopped server.
      rpc :ServerStart, ::MurmurRPC::Server, ::MurmurRPC::Void
      # ServerStop stops the given virtual server.
      rpc :ServerStop, ::MurmurRPC::Server, ::MurmurRPC::Void
      # ServerRemove removes the given virtual server and its configuration.
      rpc :ServerRemove, ::MurmurRPC::Server, ::MurmurRPC::Void
      # ServerEvents returns a stream of events that happen on the given server.
      rpc :ServerEvents, ::MurmurRPC::Server, stream(::MurmurRPC::Server::Event)
      #
      # ContextActions
      #
      #
      # ContextActionAdd adds a context action to the given user's client. The
      # following ContextAction fields must be set:
      #   context, action, text, and user.
      #
      # Added context actions are valid until:
      #  - The context action is removed with ContextActionRemove, or
      #  - The user disconnects from the server, or
      #  - The server stops.
      rpc :ContextActionAdd, ::MurmurRPC::ContextAction, ::MurmurRPC::Void
      # ContextActionRemove removes a context action from the given user's client.
      # The following ContextAction must be set:
      #   action
      # If no user is given, the context action is removed from all users.
      rpc :ContextActionRemove, ::MurmurRPC::ContextAction, ::MurmurRPC::Void
      # ContextActionEvents returns a stream of context action events that are
      # triggered by users.
      rpc :ContextActionEvents, ::MurmurRPC::ContextAction, stream(::MurmurRPC::ContextAction)
      #
      # TextMessage
      #
      #
      # TextMessageSend sends the given TextMessage to the server.
      #
      # If no users, channels, or trees are added to the TextMessage, the message
      # will be broadcast the entire server. Otherwise, the message will be
      # targeted to the specified users, channels, and trees.
      rpc :TextMessageSend, ::MurmurRPC::TextMessage, ::MurmurRPC::Void
      # TextMessageFilter filters text messages on a given server.
      # TextMessageFilter filters text messages for a given server.
      #
      # When a filter stream is active, text messages sent from users to the
      # server are sent over the stream. The RPC client then sends a message back
      # on the same stream, containing an action: whether the message should be
      # accepted, rejected, or dropped.
      #
      # To activate the filter stream, an initial TextMessage.Filter message must
      # be sent that contains the server on which the filter will be active.
      rpc :TextMessageFilter, stream(::MurmurRPC::TextMessage::Filter), stream(::MurmurRPC::TextMessage::Filter)
      #
      # Logs
      #
      #
      # LogQuery returns a list of log entries from the given server.
      #
      # To get the total number of log entries, omit min and/or max from the
      # query.
      rpc :LogQuery, ::MurmurRPC::Log::Query, ::MurmurRPC::Log::List
      #
      # Config
      #
      #
      # ConfigGet returns the explicitly set configuration for the given server.
      rpc :ConfigGet, ::MurmurRPC::Server, ::MurmurRPC::Config
      # ConfigGetField returns the configuration value for the given key.
      rpc :ConfigGetField, ::MurmurRPC::Config::Field, ::MurmurRPC::Config::Field
      # ConfigSetField sets the configuration value to the given value.
      rpc :ConfigSetField, ::MurmurRPC::Config::Field, ::MurmurRPC::Void
      # ConfigGetDefault returns the default server configuration.
      rpc :ConfigGetDefault, ::MurmurRPC::Void, ::MurmurRPC::Config
      #
      # Channels
      #
      #
      # ChannelQuery returns a list of channels that match the given query.
      rpc :ChannelQuery, ::MurmurRPC::Channel::Query, ::MurmurRPC::Channel::List
      # ChannelGet returns the channel with the given ID.
      rpc :ChannelGet, ::MurmurRPC::Channel, ::MurmurRPC::Channel
      # ChannelAdd adds the channel to the given server. The parent and name of
      # the channel must be set.
      rpc :ChannelAdd, ::MurmurRPC::Channel, ::MurmurRPC::Channel
      # ChannelRemove removes the given channel from the server.
      rpc :ChannelRemove, ::MurmurRPC::Channel, ::MurmurRPC::Void
      # ChannelUpdate updates the given channel's attributes. Only the fields that
      # are set will be updated.
      rpc :ChannelUpdate, ::MurmurRPC::Channel, ::MurmurRPC::Channel
      #
      # Users
      #
      #
      # UserQuery returns a list of connected users who match the given query.
      rpc :UserQuery, ::MurmurRPC::User::Query, ::MurmurRPC::User::List
      # UserGet returns information on the connected user, given by the user's
      # session or name.
      rpc :UserGet, ::MurmurRPC::User, ::MurmurRPC::User
      # UserUpdate changes the given user's state. Only the following fields can
      # be changed:
      #   name, mute, deaf, suppress, priority_speaker, channel, comment.
      rpc :UserUpdate, ::MurmurRPC::User, ::MurmurRPC::User
      # UserKick kicks the user from the server.
      rpc :UserKick, ::MurmurRPC::User::Kick, ::MurmurRPC::Void
      #
      # Tree
      #
      #
      # TreeQuery returns a representation of the given server's channel/user
      # tree.
      rpc :TreeQuery, ::MurmurRPC::Tree::Query, ::MurmurRPC::Tree
      #
      # Bans
      #
      #
      # BansGet returns a list of bans for the given server.
      rpc :BansGet, ::MurmurRPC::Ban::Query, ::MurmurRPC::Ban::List
      # BansSet replaces the server's ban list with the given list.
      rpc :BansSet, ::MurmurRPC::Ban::List, ::MurmurRPC::Void
      #
      # ACL
      #
      #
      # ACLGet returns the ACL for the given channel.
      rpc :ACLGet, ::MurmurRPC::Channel, ::MurmurRPC::ACL::List
      # ACLSet overrides the ACL of the given channel to what is provided.
      rpc :ACLSet, ::MurmurRPC::ACL::List, ::MurmurRPC::Void
      # ACLGetEffectivePermissions returns the effective permissions for the given
      # user in the given channel.
      rpc :ACLGetEffectivePermissions, ::MurmurRPC::ACL::Query, ::MurmurRPC::ACL
      # ACLAddTemporaryGroup adds a user to a temporary group.
      rpc :ACLAddTemporaryGroup, ::MurmurRPC::ACL::TemporaryGroup, ::MurmurRPC::Void
      # ACLRemoveTemporaryGroup removes a user from a temporary group.
      rpc :ACLRemoveTemporaryGroup, ::MurmurRPC::ACL::TemporaryGroup, ::MurmurRPC::Void
      #
      # Authenticator
      #
      #
      # AuthenticatorStream opens an authentication stream to the server.
      #
      # There can only be one RPC client with an open Stream. If a new
      # authenticator connects, the open connected will be closed.
      rpc :AuthenticatorStream, stream(::MurmurRPC::Authenticator::Response), stream(::MurmurRPC::Authenticator::Request)
      #
      # Database
      #
      #
      # DatabaseUserQuery returns a list of registered users who match given
      # query.
      rpc :DatabaseUserQuery, ::MurmurRPC::DatabaseUser::Query, ::MurmurRPC::DatabaseUser::List
      # DatabaseUserGet returns the database user with the given ID.
      rpc :DatabaseUserGet, ::MurmurRPC::DatabaseUser, ::MurmurRPC::DatabaseUser
      # DatabaseUserUpdate updates the given database user.
      rpc :DatabaseUserUpdate, ::MurmurRPC::DatabaseUser, ::MurmurRPC::Void
      # DatabaseUserRegister registers a user with the given information on the
      # server. The returned DatabaseUser will contain the newly registered user's
      # ID.
      rpc :DatabaseUserRegister, ::MurmurRPC::DatabaseUser, ::MurmurRPC::DatabaseUser
      # DatabaseUserDeregister deregisters the given user.
      rpc :DatabaseUserDeregister, ::MurmurRPC::DatabaseUser, ::MurmurRPC::Void
      # DatabaseUserVerify verifies the that the given user-password pair is
      # correct.
      rpc :DatabaseUserVerify, ::MurmurRPC::DatabaseUser::Verify, ::MurmurRPC::DatabaseUser
      #
      # Audio
      #
      #
      # AddRedirectWhisperGroup add a whisper targets redirection for the given
      # user. Whenever a user whispers to group "source", the whisper will be
      # redirected to group "target".
      rpc :RedirectWhisperGroupAdd, ::MurmurRPC::RedirectWhisperGroup, ::MurmurRPC::Void
      # RemoveRedirectWhisperGroup removes a whisper target redirection for
      # the the given user.
      rpc :RedirectWhisperGroupRemove, ::MurmurRPC::RedirectWhisperGroup, ::MurmurRPC::Void
    end

    Stub = Service.rpc_stub_class
  end
  #
  # Meta
  #
end
